document.addEventListener('DOMContentLoaded', function() {
  const FLOATING_BUTTON_ENABLED = true;

  const hamburgerIconContainer = document.getElementById('hamburger-icon-container');
  const closeIcon = document.getElementById('close-icon');
  const overlayMenuContainer = document.getElementById('overlay-menu-container');
  const overlayMenuContent = document.getElementById('overlay-menu-content');
  const minDistanceToClose = 20; // Mindestabstand in Pixeln

  let autoCollapseSubmenus = true;
  let elementsWithCustomClickHandlers = [hamburgerIconContainer, closeIcon];

  hamburgerIconContainer.addEventListener('click', function() {
    if (overlayMenuContainer.style.display === 'block') {
      overlayMenuContainer.style.display = 'none';
    } else {
      overlayMenuContainer.style.display = 'block';
      // Setze die Klasse "open" zurück
      const openItems = document.querySelectorAll('.overlay-menu-item.open, .overlay-menu-item-content.open');
      openItems.forEach(item => item.classList.remove('open'));
      // Füge die Klasse "open" zum Menü-Element mit "has-current-submenu-active" hinzu
      setOpenClassOnCurrentSubmenuActiveItem();
    }
  });

  closeIcon.addEventListener('click', function() {
    overlayMenuContainer.style.display = 'none';
  });

  function setOpenClassOnCurrentSubmenuActiveItem() {
    // console.log('Funktion setOpenClassOnCurrentSubmenuActiveItem() wird aufgerufen');

    const currentSubmenuActiveItem = document.querySelector('.overlay-menu-item.has-current-submenu-active');
  
    if (currentSubmenuActiveItem) {
      // console.log('Menü-Element mit "has-current-submenu-active" gefunden:', currentSubmenuActiveItem);
    
      currentSubmenuActiveItem.classList.add('open');
      // console.log('Klasse "open" mit classList.add() hinzugefügt');
    
      currentSubmenuActiveItem.className += ' open';
      // console.log('Klasse "open" mit className hinzugefügt');
    
      // console.log('Klassen des Elements nach Hinzufügen von "open":', currentSubmenuActiveItem.classList);
    
      // Überprüfung, ob die Klasse "open" korrekt hinzugefügt wurde
      const hasOpenClass = currentSubmenuActiveItem.classList.contains('open');
      // console.log('Überprüfung: Hat das Element die Klasse "open"?', hasOpenClass);
    
      // Erneute Evaluierung des Elements
      const reevaluatedElement = document.querySelector('.overlay-menu-item.has-current-submenu-active');
      // console.log('Erneut evaluiertes Element:', reevaluatedElement);
      // console.log('Klassen des erneut evaluierten Elements:', reevaluatedElement.classList);
    
  } else {
    // console.log('Kein Menü-Element mit "has-current-submenu-active" gefunden');
  }
}
    
function createOverlayMenu() {
  const headlineMenu = document.getElementById('headline-menu');
  const overlayMenu = headlineMenu.cloneNode(true);
  overlayMenu.id = 'overlay-menu';

  const menuItems = overlayMenu.querySelectorAll('.headline-menu-item');
  menuItems.forEach(function(menuItem) {
    menuItem.classList.remove('headline-menu-item');
    menuItem.classList.add('overlay-menu-item');

    // console.log('Menü-Element gefunden:', menuItem);

    // Überprüfe, ob das Menü-Element die Klasse 'has-current-submenu-active' hat
    if (menuItem.classList.contains('has-current-submenu-active')) {
      menuItem.classList.remove('has-current-submenu-active');
      menuItem.classList.add('has-current-submenu-active', 'open');
      // console.log('Menü-Element mit "has-current-submenu-active" gefunden und "open" hinzugefügt');
    }

    const overlaySubmenuItems = menuItem.querySelectorAll('.headline-menu-submenu-item');
    overlaySubmenuItems.forEach(function(submenuItem) {
      submenuItem.classList.remove('headline-menu-submenu-item');
      submenuItem.classList.add('overlay-menu-submenu-item');

      // console.log('Untermenü-Element gefunden:', submenuItem);

      // Überprüfe, ob das Untermenü-Element die Klasse 'current-active' hat
      if (submenuItem.classList.contains('current-active')) {
        submenuItem.classList.remove('current-active');
        submenuItem.classList.add('current-active');
        // console.log('Untermenü-Element mit "current-active" gefunden');
      }

      const moveUpBtn = submenuItem.querySelector('.headline-menu-move-up-btn');
      if (moveUpBtn) {
        moveUpBtn.classList.remove('headline-menu-move-up-btn');
        moveUpBtn.classList.add('overlay-menu-move-up-btn');
      }

      const moveDownBtn = submenuItem.querySelector('.headline-menu-move-down-btn');
      if (moveDownBtn) {
        moveDownBtn.classList.remove('headline-menu-move-down-btn');
        moveDownBtn.classList.add('overlay-menu-move-down-btn');
      }

      const addSubmenuBtn = submenuItem.querySelector('.headline-menu-add-submenu-btn');
      if (addSubmenuBtn) {
        addSubmenuBtn.classList.remove('headline-menu-add-submenu-btn');
        addSubmenuBtn.classList.add('overlay-menu-add-submenu-btn');
        addSubmenuBtn.addEventListener('click', function(event) {
          event.stopPropagation();
          addSubmenuItem(menuItem);
        });
      }

      // Hier entfernen wir den Link Button, den wir im Overlay aktuell nicht brauchen
      const linkMenuBtn = submenuItem.querySelector('.headline-menu-link-btn');
      if (linkMenuBtn) {
        linkMenuBtn.classList.remove('headline-menu-link-btn');
        //linkMenuBtn.classList.add('overlay-menu-link-submenu-btn');
        linkMenuBtn.addEventListener('click', function(event) {
          event.stopPropagation();
          deleteSubmenuItem(submenuItem);
        });
        linkMenuBtn.remove(); // Ich weiß nicht, warum dieser Button hier überhaupt existiert, während das bei den anderen Buttons nicht der Fall ist?
      }

      const delSubmenuBtn = submenuItem.querySelector('.headline-menu-del-submenu-btn');
      if (delSubmenuBtn) {
        delSubmenuBtn.classList.remove('headline-menu-del-submenu-btn');
        delSubmenuBtn.classList.add('overlay-menu-del-submenu-btn');
        delSubmenuBtn.addEventListener('click', function(event) {
          event.stopPropagation();
          deleteSubmenuItem(submenuItem);
        });
      }

        
      submenuItem.addEventListener('click', function(event) {
        event.stopPropagation();

        // Entferne die Klasse "active" von allen Untermenü-Punkten
        overlaySubmenuItems.forEach(function(item) {
          item.classList.remove('active');
        });

        // Füge die Klasse "active" zum angeklickten Untermenü-Punkt hinzu
        submenuItem.classList.add('active');
      });
    });

    const submenu = menuItem.querySelector('.headline-menu-submenu');
    if (submenu) {
      submenu.classList.remove('headline-menu-submenu');
      submenu.classList.add('overlay-menu-submenu');
    }

    const itemContent = menuItem.querySelector('.headline-menu-item-content');
    if (itemContent) {
      itemContent.classList.remove('headline-menu-item-content');
      itemContent.classList.add('overlay-menu-item-content');

      // console.log('Inhaltselement gefunden:', itemContent);

      // Überprüfe, ob das Inhaltselement die Klasse 'current-active' hat
      if (itemContent.classList.contains('current-active')) {
        itemContent.classList.remove('current-active');
        itemContent.classList.add('current-active');
        // console.log('Inhaltselement mit "current-active" gefunden');
      }

      // Füge einen Klick-Event-Listener zum Inhaltselement hinzu
      itemContent.addEventListener('click', function(event) {
        event.stopPropagation();

        // console.log('Inhaltselement angeklickt:', itemContent);

        // Überprüfe, ob das angeklickte Element ein Link ist oder einen Link enthält
        const link = itemContent.querySelector('a');
        if (link) {
          // console.log('Angeklicktes Element enthält einen Link, Link wird ausgeführt');
          link.click(); // Führe den Klick auf den Link aus
          return;
        }

        // console.log('Angeklicktes Element ist kein Link, Menü-Element wird geöffnet/geschlossen');

        // Andernfalls, öffne/schließe das Menü-Element
        if (autoCollapseSubmenus) {
          const openItems = overlayMenuContent.querySelectorAll('.overlay-menu-item.open');
          openItems.forEach(function(item) {
            if (item !== menuItem) {
              item.classList.remove('open');
            }
          });
        }

        menuItem.classList.toggle('open');
      });
    }

    const moveLeftBtn = menuItem.querySelector('.headline-menu-move-left-btn');
    if (moveLeftBtn) {
      moveLeftBtn.classList.remove('headline-menu-move-left-btn');
      moveLeftBtn.classList.add('overlay-menu-move-left-btn');
    }

    const moveRightBtn = menuItem.querySelector('.headline-menu-move-right-btn');
    if (moveRightBtn) {
      moveRightBtn.classList.remove('headline-menu-move-right-btn');
      moveRightBtn.classList.add('overlay-menu-move-right-btn');
    }

    const addMenuBtn = menuItem.querySelector('.headline-menu-add-menu-btn');
    if (addMenuBtn) {
      addMenuBtn.classList.remove('headline-menu-add-menu-btn');
      addMenuBtn.classList.add('overlay-menu-add-menu-btn');
      addMenuBtn.addEventListener('click', function(event) {
        event.stopPropagation();
        addMenuItem();
      });
    }

    const delMenuBtn = menuItem.querySelector('.headline-menu-del-menu-btn');
    if (delMenuBtn) {
      delMenuBtn.classList.remove('headline-menu-del-menu-btn');
      delMenuBtn.classList.add('overlay-menu-del-menu-btn');
      delMenuBtn.addEventListener('click', function(event) {
        event.stopPropagation();
        deleteMenuItem(menuItem);
      });
    }
  });

  // Hierarchisches Entfernen der Klassen 'editable' und 'contenteditable'
  removeClassFromElementAndChildren(overlayMenu, 'editable');
  removeAttributeFromElementAndChildren(overlayMenu, 'contenteditable');

  overlayMenuContent.innerHTML = '';
  overlayMenuContent.appendChild(overlayMenu);

  // console.log('Overlay-Menü erstellt und in den DOM eingefügt');
}

  function removeClassFromElementAndChildren(startElement, className) {
    // Überprüfe das startElement und entferne die Klasse falls vorhanden
    if (startElement.classList.contains(className)) {
      startElement.classList.remove(className);
    }

    // Gehe durch alle Kind-Elemente rekursiv
    startElement.childNodes.forEach(child => {
      if (child.nodeType === Node.ELEMENT_NODE) {
        removeClassFromElementAndChildren(child, className);
      }
    });
  }

  function removeAttributeFromElementAndChildren(startElement, attributeName) {
    // Entferne das Attribut vom Startelement, falls vorhanden
    if (startElement.hasAttribute(attributeName)) {
      startElement.removeAttribute(attributeName);
    }

    // Gehe durch alle Kind-Elemente rekursiv
    startElement.childNodes.forEach(child => {
      if (child.nodeType === Node.ELEMENT_NODE) {
        removeAttributeFromElementAndChildren(child, attributeName);
      }
    });
  }

  function addMenuItem() {
    const newMenuItem = document.createElement('div');
    newMenuItem.className = 'overlay-menu-item fade-in';
    newMenuItem.innerHTML = `
      <div class="overlay-menu-item-content">
        <button class="overlay-menu-move-left-btn">&#8592;</button>
        <span class="editable">Neues Menü</span>
        <button class="overlay-menu-move-right-btn">&#8594;</button>
        <button class="overlay-menu-del-menu-btn">&#10005;</button>
      </div>
      <div class="overlay-menu-submenu">
        <div class="overlay-menu-submenu-item">
          <button class="overlay-menu-add-submenu-btn">+</button>
        </div>
      </div>
    `;
    overlayMenuContent.insertBefore(newMenuItem, overlayMenuContent.lastElementChild);
  }

  function addSubmenuItem(menuItem) {
    const submenu = menuItem.querySelector('.overlay-menu-submenu');
    const newSubmenuItem = document.createElement('div');
    newSubmenuItem.className = 'overlay-menu-submenu-item fade-in';
    newSubmenuItem.innerHTML = `
      <button class="overlay-menu-move-up-btn">&#8593;</button>
      <button class="overlay-menu-move-down-btn">&#8595;</button>
      <a href="#" class="editable">Neues Untermenü</a>
      <button class="overlay-menu-del-submenu-btn">&#10005;</button>
    `;
    submenu.insertBefore(newSubmenuItem, submenu.lastElementChild);
  }

  function deleteMenuItem(menuItem) {
    menuItem.remove();
  }

  function deleteSubmenuItem(submenuItem) {
    submenuItem.remove();
  }

  createOverlayMenu();

  let headlineMenuContainer = document.getElementById('headline-menu-container');
  
  if (!headlineMenuContainer) {
    console.warn("Element mit ID 'headline-menu-container' nicht gefunden. Verwende 'headline-menu' als Fallback.");
    headlineMenuContainer = document.getElementById('headline-menu');
  }

  if (headlineMenuContainer) {
    const observer = new MutationObserver(function(mutations) {
      mutations.forEach(function(mutation) {
        if (mutation.type === 'childList') {
          createOverlayMenu();
        }
      });
    });
    observer.observe(headlineMenuContainer, { childList: true, subtree: true });
  } else {
    console.error("Weder 'headline-menu-container' noch 'headline-menu' gefunden. MutationObserver kann nicht angewendet werden.");
  }

  document.addEventListener('click', function(event) {
    const menuItems = document.querySelectorAll('.overlay-menu-item');
    // Dieser Code wird scheinbar nur beim initialen Öffnen des Menüs aufgerufen
    // console.log("initial open overlay menu click");
    menuItems.forEach(function(menuItem) {
      if (!menuItem.contains(event.target) && !event.target.closest('.overlay-menu-submenu')) {
        menuItem.classList.remove('open');
      }
    });

    // hier müssen wir dann das default open setzen
    setOpenClassOnCurrentSubmenuActiveItem();
    

    if (elementsWithCustomClickHandlers.includes(event.target) || elementsWithCustomClickHandlers.some(el => el.contains(event.target))) {
      return;
    }

    if (!overlayMenuContainer.contains(event.target)) {
      overlayMenuContainer.style.display = 'none';
    }
  });

  document.addEventListener('click', handleClick);

  function handleClick(event) {
    if (overlayMenuContainer.style.display === 'none' || elementsWithCustomClickHandlers.includes(event.target) || elementsWithCustomClickHandlers.some(el => el.contains(event.target))) {
      return;
    }

    if (event.target.closest('.overlay-menu-submenu-item')) {
      return;
    }

    // const elements = Array.from(document.querySelectorAll('a, button, input, [role="button"], #hamburger-icon, #hamburger-icon *, #close-icon, #close-icon *'));
    const elements = Array.from(document.querySelectorAll('a, button, input, [role="button"], #close-icon, #close-icon *'));
      
    let minDistance = Infinity;
    let closestElement = null;

    elements.forEach(element => {
      const rect = element.getBoundingClientRect();
      const distanceX = Math.max(rect.left - event.clientX, event.clientX - rect.right, 0);
      const distanceY = Math.max(rect.top - event.clientY, event.clientY - rect.bottom, 0);
      const distance = Math.sqrt(distanceX ** 2 + distanceY ** 2);

      if (distance < minDistance) {
        minDistance = distance;
        closestElement = element;
      }
    });

    if (minDistance > minDistanceToClose) {
      overlayMenuContainer.style.display = 'none';
    }
  }

  if (FLOATING_BUTTON_ENABLED) {
    let floatingHamburgerButton = document.getElementById('floating-hamburger-button');

    if (!floatingHamburgerButton) {
      floatingHamburgerButton = document.createElement('div');
      floatingHamburgerButton.id = 'floating-hamburger-button';
      floatingHamburgerButton.innerHTML = `
        <div id="floating-hamburger-icon">
          <svg viewBox="0 0 100 80" width="30" height="30" fill="none" stroke="white" stroke-width="8">
            <path d="M 20 20 L 80 20 M 20 40 L 80 40 M 20 60 L 80 60" />
          </svg>
        </div>
      `;
      document.body.appendChild(floatingHamburgerButton);
    }

    elementsWithCustomClickHandlers.push(floatingHamburgerButton);

    floatingHamburgerButton.addEventListener('click', function() {
      if (overlayMenuContainer.style.display === 'block') {
        overlayMenuContainer.style.display = 'none';
      } else {
        overlayMenuContainer.style.display = 'block';
      }
    });

    const minOpacity = 0.2;
    floatingHamburgerButton.style.opacity = minOpacity; // Setze die Anfangs-Opacity auf den Minimalwert

    window.addEventListener('scroll', function() {
      const scrollPosition = window.scrollY;
      const windowHeight = window.innerHeight;
      const documentHeight = document.documentElement.scrollHeight;
      const scrollPercentage = scrollPosition / (documentHeight - windowHeight);

      const maxOpacity = 0.9;
      const opacity = minOpacity + (maxOpacity - minOpacity) * scrollPercentage;

      floatingHamburgerButton.style.opacity = opacity;
    });

    floatingHamburgerButton.addEventListener('mouseenter', function() {
      floatingHamburgerButton.style.opacity = 1;
    });

    floatingHamburgerButton.addEventListener('mouseleave', function() {
      const scrollPosition = window.scrollY;
      const windowHeight = window.innerHeight;
      const documentHeight = document.documentElement.scrollHeight;
      const scrollPercentage = scrollPosition / (documentHeight - windowHeight);

      const maxOpacity = 0.9;
      const opacity = minOpacity + (maxOpacity - minOpacity) * scrollPercentage;

      floatingHamburgerButton.style.opacity = opacity;
    });
  }
});
